Parameter eq : forall (A:Type), A -> A -> Prop.
Axiom refl : forall A, forall (x:A), eq (A) x x.
Axiom eq_ind : forall A, forall (x:A), forall (P:(A -> Prop)), (P x) -> forall (y:A), (eq (A) x y) -> P y.
Definition rewrite_l : forall A, forall (x:A), forall (P:(A -> Prop)), (P x) -> forall (y:A), (eq (A) x y) -> P y := fun (A:Type) => fun (x:A) => fun (P:A -> Prop) => fun (Hx:P x) => (fun (y:A) => fun (Heq:eq (A) x y) => (((((((eq_ind) (A)) (x)) (fun (__:A) => P __)) (Hx)) (y)) (Heq))).
Definition sym_eq : forall A, forall (x:A), forall (y:A), (eq (A) x y) -> eq (A) y x := fun (A:Type) => fun (x:A) => fun (y:A) => fun (Heq:eq (A) x y) => (((((((rewrite_l) (A)) (x)) (fun (__:A) => eq (A) __ x)) (((refl) (A)) (x))) (y)) (((((((rewrite_l) (A)) (x)) (fun (__:A) => eq (A) x __)) (((refl) (A)) (x))) (y)) (Heq))).
Definition rewrite_r : forall A, forall (x:A), forall (P:(A -> Prop)), (P x) -> forall (y:A), (eq (A) y x) -> P y := fun (A:Type) => fun (x:A) => fun (P:A -> Prop) => fun (Hx:P x) => (fun (y:A) => fun (Heq:eq (A) y x) => (((((((eq_ind) (A)) (x)) (fun (__:A) => P __)) (Hx)) (y)) (((((sym_eq) (A)) (y)) (x)) (Heq)))).
